/*=========================================================================
                                                                                
  Program:   bbtk
  Module:    $RCSfile: bbkwViewer3D.h,v $
  Language:  C++
  Date:      $Date: 2008/12/16 12:48:08 $
  Version:   $Revision: 1.1 $
                                                                                
  Copyright (c) CREATIS (Centre de Recherche et d'Applications en Traitement de
  l'Image). All rights reserved. See Doc/License.txt or
  http://www.creatis.insa-lyon.fr/Public/bbtk/License.html for details.
                                                                                
     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.
                                                                                
=========================================================================*//**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief Pattern for the definition of a new type of Node (header)
 */
/**
 * \class bbtk::NodePatern 
 * \brief Pattern for the definition of a new type of Node 
 */


#ifdef USE_KWWIDGETS
#ifdef USE_VTK


#ifndef __bbkwViewer3D_h__
#define __bbkwViewer3D_h__

#include "bbtkKWBlackBox.h"
#include "vtkProp3D.h"
#include "vtkInteractorObserver.h"

#include "bbkw_EXPORT.h"

namespace bbkw
{

  //------------------------------------------------------------------------  
  class bbkw_EXPORT kwViewer3D : public bbtk::KWBlackBox
  {    
    BBTK_BLACK_BOX_INTERFACE(kwViewer3D,bbtk::KWBlackBox);
    BBTK_DECLARE_INPUT(In1, vtkProp3D *);
    BBTK_DECLARE_INPUT(In2, vtkProp3D *);
    BBTK_DECLARE_INPUT(In3, vtkProp3D *);
    BBTK_DECLARE_INPUT(In4, vtkProp3D *);
    BBTK_DECLARE_INPUT(In5, vtkProp3D *);
    BBTK_DECLARE_INPUT(Obs1, vtkInteractorObserver *);
    BBTK_DECLARE_INPUT(Obs2, vtkInteractorObserver *);
    BBTK_DECLARE_INPUT(Obs3, vtkInteractorObserver *);
    BBTK_DECLARE_INPUT(Obs4, vtkInteractorObserver *);
    BBTK_DECLARE_INPUT(Obs5, vtkInteractorObserver *);
    BBTK_PROCESS(Process);
    BBTK_CREATE_KWWIDGET(CreateWidget);
    //    BBTK_ON_SHOW_WIDGET(OnShowWidget);
  
    void Process();
    void CreateWidget(vtkKWFrame*);
    //    void OnShowWidget();

  protected:
    virtual void bbUserConstructor();
    virtual void bbUserDestructor();
  };
   
  //=================================================================
  // UserBlackBox description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(kwViewer3D,bbtk::KWBlackBox);
  BBTK_NAME("kwViewer3D");
  BBTK_AUTHOR("laurent.guigues@creatis.insa-lyon.fr");
  BBTK_DESCRIPTION("3D viewer widget (vtkKWRenderWidget)");
  BBTK_CATEGORY("viewer");
  BBTK_INPUT(kwViewer3D,In1,"Input actor",vtkProp3D *,"");
  BBTK_INPUT(kwViewer3D,In2,"Input actor",vtkProp3D *,"");
  BBTK_INPUT(kwViewer3D,In3,"Input actor",vtkProp3D *,"");
  BBTK_INPUT(kwViewer3D,In4,"Input actor",vtkProp3D *,"");
  BBTK_INPUT(kwViewer3D,In5,"Input actor",vtkProp3D *,"");
  BBTK_INPUT(kwViewer3D,Obs1,"Input observer",vtkInteractorObserver *,"");
  BBTK_INPUT(kwViewer3D,Obs2,"Input observer",vtkInteractorObserver *,"");
  BBTK_INPUT(kwViewer3D,Obs3,"Input observer",vtkInteractorObserver *,"");
  BBTK_INPUT(kwViewer3D,Obs4,"Input observer",vtkInteractorObserver *,"");
  BBTK_INPUT(kwViewer3D,Obs5,"Input observer",vtkInteractorObserver *,"");
  BBTK_END_DESCRIBE_BLACK_BOX(kwViewer3D);
  //=================================================================


}//namespace bbtk

#endif  //__bbkwViewer3D_h__

#endif //USE_KW
#endif //USE_VTK
 
