/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbvtkConcatImages.h,v $
  Language:  C++
  Date:      $Date: 2010/04/08 14:39:46 $
  Version:   $Revision: 1.1 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief Pattern for the definition of a new type of Node (header)
 */
/**
 * \class bbtk::NodePatern 
 * \brief Pattern for the definition of a new type of Node 
 */
 
#ifdef _USE_VTK_

#ifndef __bbvtkConcatImages_h_INCLUDED__
#define __bbvtkConcatImages_h_INCLUDED__
#include "bbvtk_EXPORT.h"

#include "bbtkAtomicBlackBox.h"

#include "vtkImageData.h"

namespace bbvtk
{
  class bbvtk_EXPORT ConcatImages : public bbtk::AtomicBlackBox
  { 
  public:
    BBTK_BLACK_BOX_INTERFACE(ConcatImages, bbtk::AtomicBlackBox);
    BBTK_DECLARE_INPUT(In, std::vector<vtkImageData *>);
    BBTK_DECLARE_OUTPUT(Out, vtkImageData*);    
    BBTK_PROCESS(Process);
    void Process();
  protected:
  private:
     vtkImageData *mConcat;    
  };

  //=================================================================
  // UserBlackBox description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(ConcatImages,bbtk::AtomicBlackBox);
  BBTK_NAME("ConcatImages");
  BBTK_AUTHOR("jpr@creatis.univ-lyon.fr");
  BBTK_DESCRIPTION("Concatenates all the 'images' held in a std::vector<vtkImageData*> into a single vtkImageData");
  BBTK_CATEGORY("application, image");
  BBTK_INPUT(ConcatImages, In, "Input Vector of Images", std::vector<vtkImageData *>, "");
  BBTK_OUTPUT(ConcatImages, Out, "Concatenation of all Images", vtkImageData *, "");
  BBTK_END_DESCRIBE_BLACK_BOX(ConcatImages);   
  //=================================================================

}//namespace bbvtk
   
#endif  //__bbtvtkConcatImages_h__
#endif //_USE_VTK_
