#ifndef __bbvtkImageCastToUShort_h_INCLUDED__
#define __bbvtkImageCastToUShort_h_INCLUDED__
#include "bbvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageData.h"
#include "vtkImageCast.h"

namespace bbvtk
{

class bbvtk_EXPORT ImageCastToUShort
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ImageCastToUShort,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();

private:
	vtkImageCast* cast;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ImageCastToUShort, bbtk::AtomicBlackBox);
BBTK_NAME("ImageCastToUShort");
BBTK_AUTHOR("car-prie@uniandes.edu.co");
BBTK_DESCRIPTION("Cast an Image to UShort");
BBTK_CATEGORY("filter, image");
BBTK_INPUT(ImageCastToUShort, In, "First input", vtkImageData*, "");
BBTK_OUTPUT(ImageCastToUShort, Out, "First output", vtkImageData*, "");
BBTK_END_DESCRIBE_BLACK_BOX(ImageCastToUShort);
}
// EO namespace bbvtk

#endif // __bbvtkImageCastToUShort_h_INCLUDED__
